#include <stdio.h>

#include "bmp.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>


#include <stdarg.h>
#include <string.h>
int fwrite_string(FILE *file, char *format, ...)
{
	char tmp[1024];
	va_list argptr;
	va_start(argptr, format);
	_vsnprintf(tmp, 1024, format, argptr);
	return fwrite(tmp, 1, strlen(tmp), file);
}


void DebugBitmapInfo(BITMAPINFO *BitmapInfo)
{
	int bitsize =  ((BitmapInfo)->bmiHeader.biWidth *
                   (BitmapInfo)->bmiHeader.biBitCount + 7) / 8 *
  	           abs((BitmapInfo)->bmiHeader.biHeight);

	printf("%dx%dx%dbit bitsize:%d\n",
		BitmapInfo->bmiHeader.biWidth,
		BitmapInfo->bmiHeader.biHeight,
		BitmapInfo->bmiHeader.biBitCount,
		bitsize
	);
}

int main()
{
	BITMAPINFO *BitmapInfo;
	unsigned char *BitmapBits;

	//BitmapBits = LoadDIBitmap("d:\\bmp2mesh\\80x80.bmp", &BitmapInfo);
	BitmapBits = LoadDIBitmap("dayz.bmp", &BitmapInfo);
	//BitmapBits = LoadDIBitmap("d:\\bmp2mesh\\40x40.bmp", &BitmapInfo);
	//BitmapBits = LoadDIBitmap("d:\\bmp2mesh\\bmp2mesh.bmp", &BitmapInfo);
	//BitmapBits = LoadDIBitmap("d:\\bmp2mesh\\15x7.bmp", &BitmapInfo);
	//BitmapBits = LoadDIBitmap("d:\\bmp2mesh\\8x2.bmp", &BitmapInfo);
	//BitmapBits = LoadDIBitmap("d:\\bmp2mesh\\first2.bmp", &BitmapInfo);

	int width = BitmapInfo->bmiHeader.biWidth;
	int height = BitmapInfo->bmiHeader.biHeight;

	int i, j;
	//FILE *mesh = fopen("d:\\bmp2mesh\\first.map", "w");
	FILE *mesh = fopen("dayz.map", "w");







#if 0
	int ii;
	
	ii=0;
	//for (j=0; j<width; j++) // go through all pixels of line
	for (i=height-1; i>=0; i--, ii++) // line by line, but they are saved reversed
	{
		//for (i=height-1; i>=0; i--, ii++) // line by line, but they are saved reversed
		for (j=0; j<width; j++) // go through all pixels of line
		{
			int pos = (j*3) + (3*width*i);

			int r = BitmapBits[pos+0];
			int g = BitmapBits[pos+1];
			int b = BitmapBits[pos+2];

			//printf("pos=%d (%d,%d,%d)\n", pos, r, g, b);
			if (r+g+b > 10)
				printf("#");
			else
				printf(".");
		}
	printf("\n");
	}

	printf("-----\n");



	for (i=0; i<height; i++)
	{
		for (j=0; j<width; j++)
		{
			int reversedI = (height-1)-i;
			int pos = (j*3) + (3*width*reversedI);

			int r = BitmapBits[pos+0];
			int g = BitmapBits[pos+1];
			int b = BitmapBits[pos+2];

			//printf("pos=%d (%d,%d,%d)\n", pos, r, g, b);
			if (r+g+b > 10)
				printf("#");
			else
				printf(".");
		}
		printf("\n");
	}
#endif

	fwrite_string(mesh,
		"iwmap 4\n"
		"// entity 0\n"
		"{\n"
		" \"classname\" \"worldspawn\"\n"
	);

	int quadsPerWidth = 14; //4;
	int quadsPerHeight = 14; //5;

	int a_, b_;

	int neededWidth = width / quadsPerWidth;
	int neededHeight = height / quadsPerHeight;

	for (a_=0; a_<neededWidth; a_++)
	{
		for (b_=0; b_<neededHeight; b_++)
		{
			fwrite_string(mesh,
				" // mesh %d %d\n"
				" {\n"
				"  mesh\n"
				"  {\n"
				"   case\n"
				"   lightmap_gray\n"
				"   %d %d %d %d\n",
				a_, b_,
				//width, height
				quadsPerWidth+1, quadsPerHeight+1,
				16, 16 /*texture light information?*/
			);

			//for (i=0; i<width; i++)
			for (i=0; i<quadsPerWidth+1; i++)
			{
				fwrite_string(mesh, "   (\n");

				//for (j=0; j<height; j++)
				for (j=0; j<quadsPerHeight+1; j++)
				{
					int reversedJ = (height-1)-j;
					int pos = ((i+a_*quadsPerWidth)*3) + (3*width*(j+b_*quadsPerHeight));

					int r = BitmapBits[pos+0];
					int g = BitmapBits[pos+1];
					int b = BitmapBits[pos+2];
					int average = (r+g+b) / 3;

					int left = (a_*quadsPerWidth * 64);
					int right = (b_*quadsPerHeight * 64);
					/*if (a_)
						left -= 64;
					if (b_)
						right -= 64;*/

					int x = i*64 + left;
					int y = j*64 + right;
					int z = 255 - average; // the darker the higher

					fwrite_string(mesh, "    v %d %d %d t 0 0 4 -4 // %d:%d(%d)|%d,%d,%d|%d left/right=%d,%d\n",
						x,y,z,
						/*debug info after comment*/
						i,j,pos, 
						r,g,b,
						average,
						left, right
					);
				}
				fwrite_string(mesh, "   )\n");
			}

			fwrite_string(mesh, "  }\n }\n");
		}
	}

	fwrite_string(mesh, "}\n");

	fclose(mesh);

	DebugBitmapInfo(BitmapInfo);

	getchar();
	return 0;
}